package pro.litvinovg.w2phtml.gui;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

public class UIPreferences {
	private Map<String,ArrayList<String>> prefs;
	
	private String sourceFileName = "";
	
	public UIPreferences() {
		prefs = new HashMap<String,ArrayList<String>>();
	}
			
	public UIPreferences(Map<String,ArrayList<String>> sourcePrefs) {
		Iterator<Entry<String, ArrayList<String>>> it = sourcePrefs.entrySet().iterator();
		while (it.hasNext()) {
			Entry<String, ArrayList<String>> pair = (Entry<String, ArrayList<String>>) it.next();
			prefs = new HashMap<String,ArrayList<String>>();
			prefs.put(new String(pair.getKey()), new ArrayList<String>(pair.getValue()));
		}
	}
	
	public void put(String name, ArrayList<String>values) {
		prefs.put(name, values);
	}
	
	public String getSourceFileName() {
		return sourceFileName;
	}

	public void setSourceFileName(String sourceFileName) {
		this.sourceFileName = sourceFileName;
	}
	
	public String[] getAll(String name) {
		if (prefs.containsKey(name)) {
			return (String[]) prefs.get(name).toArray(new String[0]);
		} else {
			return new String[0];
		}
	}
	
	public String get(String name) {
		if (prefs.containsKey(name)) {
			return  prefs.get(name).get(0);
		} else {
			return "";
		}
	}
	
	public UIPreferences clone() {
		UIPreferences clonedPrefs = new UIPreferences(prefs);
		clonedPrefs.setSourceFileName(sourceFileName);
		return clonedPrefs;
	}
}
