package w2phtml.pageSplitters;

import static w2phtml.office.XMLString.TABLE_TABLE_HEADER_ROWS;
import static w2phtml.office.XMLString.TABLE_TABLE_ROW;
import static w2phtml.office.XMLString.TABLE_TABLE_ROWS;
import static w2phtml.office.XMLString.TABLE_TABLE_ROW_GROUP;
import static w2phtml.office.XMLString.TEXT_SOFT_PAGE_BREAK;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import w2phtml.office.OfficeReader;

public class TableRowGroupSplitter extends BasicSplitter implements ISplitter {

	public TableRowGroupSplitter(OfficeReader officeReader, SplitFactory factory) {
		super(officeReader, factory);
		// TODO Auto-generated constructor stub
	}

	@Override
	public SplitResults Split(Node tableRowGroup) {
		SplitResults results = new SplitResults(false);
		Node parent = tableRowGroup.getParentNode();
		Node tableRowGroupFistPart = tableRowGroup.cloneNode(false);
		// Node counter
		int i = 0;
		NodeList tableRowGroupChildNodes = tableRowGroup.getChildNodes();
		while (tableRowGroupChildNodes.getLength() > i) {
			Node tableRowGroupChildNode = tableRowGroupChildNodes.item(0);
			if ((tableRowGroupChildNode.getNodeType() == Node.ELEMENT_NODE)) {
				
				String nodeName = tableRowGroupChildNode.getNodeName();
				
				if (containsSPB(tableRowGroupChildNode)){
					if (nodeName.equals(TEXT_SOFT_PAGE_BREAK)){
						// remove inner soft page break node
						tableRowGroup.removeChild(tableRowGroupChildNode);
					
					} else if (nodeName.equals(TABLE_TABLE_HEADER_ROWS)){
						//Nothing IF table-header-rows found - it is description node, 
						//Not needed to set dataMoved = true, not needed to append First part
					
					} else if (nodeName.equals(TABLE_TABLE_ROW)){
						if (factory.split(tableRowGroupChildNode).isDataMoved()){
							results.setDataMoved(true);
							tableRowGroupFistPart.appendChild(tableRowGroupChildNode.getPreviousSibling());
						}
					} else if (nodeName.equals(TABLE_TABLE_ROW_GROUP)){
						if (factory.split(tableRowGroupChildNode).isDataMoved()){
							results.setDataMoved(true);
							tableRowGroupFistPart.appendChild(tableRowGroupChildNode.getPreviousSibling());
						}
					} else if (nodeName.equals(TABLE_TABLE_ROWS)){
						if (factory.split(tableRowGroupChildNode).isDataMoved()){
							results.setDataMoved(true);
							tableRowGroupFistPart.appendChild(tableRowGroupChildNode.getPreviousSibling());
						}
					} 
					break;
				} else {
					if (nodeName.equals(TABLE_TABLE_HEADER_ROWS)){
						tableRowGroupFistPart.appendChild(tableRowGroupChildNode.cloneNode(true));
						//increment counter
						i++;
					
					} else {
						tableRowGroupFistPart.appendChild(tableRowGroupChildNode);
						results.setDataMoved(true);
					}
				}
			} else {
				//Append text nodes
				tableRowGroupFistPart.appendChild(tableRowGroupChildNode);
				results.setDataMoved(true);
			}
			
		}
		if (results.isDataMoved()) {
			parent.insertBefore(tableRowGroupFistPart, tableRowGroup);
		}
		
		return results;
	}

}
